#include "ap_compat.h"
#include "http_core.h"
#include "http_config.h"
#include "http_protocol.h"
#include "http_log.h"

module AP_MODULE_DECLARE_DATA helloworld_module;

static int helloworld_handler(request_rec *r)
{
	if (!r->handler || strcmp(r->handler, "helloworld-handler"))
		return DECLINED;

    r->content_type = "text/html";
    ap_send_http_header(r);
    ap_rputs("<H1>Hello <i>Apache 2.2</i> World!</H1>" ,r);
	ap_log_rerror(APLOG_MARK,  APLOG_NOTICE, 0, r,"[%s@%i] hello world (%s)",__FILE__,__LINE__,r->handler);
	return OK;
}

static void register_hooks(apr_pool_t *p)
{
	ap_hook_handler(helloworld_handler, NULL, NULL, APR_HOOK_MIDDLE);
}

module AP_MODULE_DECLARE_DATA helloworld_module = {
    STANDARD20_MODULE_STUFF,
    NULL,                       /* create per-directory config structure */
    NULL,                       /* merge per-directory config structures */
    NULL,                       /* merge per-directory config structures */
    NULL,                       /* merge per-server config structures */
    NULL,                       /* merge per-server config structures */
    register_hooks              /* register hooks */
};
